commit 216bb34c3063870e1955c0bc348471eb242ed370
Author: Shikhar Bhushan <shikhar@schmizz.net>
Date:   Sun May 17 02:43:33 2009 +0000

    documentation
    
    git-svn-id: http://ncclient.googlecode.com/svn/trunk@123 6dbcf712-26ac-11de-a2f3-1373824ab735

diff --git a/docs/Makefile b/docs/Makefile
new file mode 100644
index 0000000..88891f5
--- /dev/null
+++ b/docs/Makefile
@@ -0,0 +1,88 @@
+# Makefile for Sphinx documentation
+#
+
+# You can set these variables from the command line.
+SPHINXOPTS    =
+SPHINXBUILD   = sphinx-build
+PAPER         =
+
+# Internal variables.
+PAPEROPT_a4     = -D latex_paper_size=a4
+PAPEROPT_letter = -D latex_paper_size=letter
+ALLSPHINXOPTS   = -d build/doctrees $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) source
+
+.PHONY: help clean html dirhtml pickle json htmlhelp qthelp latex changes linkcheck doctest
+
+help:
+	@echo "Please use \`make <target>' where <target> is one of"
+	@echo "  html      to make standalone HTML files"
+	@echo "  dirhtml   to make HTML files named index.html in directories"
+	@echo "  pickle    to make pickle files"
+	@echo "  json      to make JSON files"
+	@echo "  htmlhelp  to make HTML files and a HTML help project"
+	@echo "  qthelp    to make HTML files and a qthelp project"
+	@echo "  latex     to make LaTeX files, you can set PAPER=a4 or PAPER=letter"
+	@echo "  changes   to make an overview of all changed/added/deprecated items"
+	@echo "  linkcheck to check all external links for integrity"
+	@echo "  doctest   to run all doctests embedded in the documentation (if enabled)"
+
+clean:
+	-rm -rf build/*
+
+html:
+	$(SPHINXBUILD) -b html $(ALLSPHINXOPTS) build/html
+	@echo
+	@echo "Build finished. The HTML pages are in build/html."
+
+dirhtml:
+	$(SPHINXBUILD) -b dirhtml $(ALLSPHINXOPTS) build/dirhtml
+	@echo
+	@echo "Build finished. The HTML pages are in build/dirhtml."
+
+pickle:
+	$(SPHINXBUILD) -b pickle $(ALLSPHINXOPTS) build/pickle
+	@echo
+	@echo "Build finished; now you can process the pickle files."
+
+json:
+	$(SPHINXBUILD) -b json $(ALLSPHINXOPTS) build/json
+	@echo
+	@echo "Build finished; now you can process the JSON files."
+
+htmlhelp:
+	$(SPHINXBUILD) -b htmlhelp $(ALLSPHINXOPTS) build/htmlhelp
+	@echo
+	@echo "Build finished; now you can run HTML Help Workshop with the" \
+	      ".hhp project file in build/htmlhelp."
+
+qthelp:
+	$(SPHINXBUILD) -b qthelp $(ALLSPHINXOPTS) build/qthelp
+	@echo
+	@echo "Build finished; now you can run "qcollectiongenerator" with the" \
+	      ".qhcp project file in build/qthelp, like this:"
+	@echo "# qcollectiongenerator build/qthelp/ncclient.qhcp"
+	@echo "To view the help file:"
+	@echo "# assistant -collectionFile build/qthelp/ncclient.qhc"
+
+latex:
+	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) build/latex
+	@echo
+	@echo "Build finished; the LaTeX files are in build/latex."
+	@echo "Run \`make all-pdf' or \`make all-ps' in that directory to" \
+	      "run these through (pdf)latex."
+
+changes:
+	$(SPHINXBUILD) -b changes $(ALLSPHINXOPTS) build/changes
+	@echo
+	@echo "The overview file is in build/changes."
+
+linkcheck:
+	$(SPHINXBUILD) -b linkcheck $(ALLSPHINXOPTS) build/linkcheck
+	@echo
+	@echo "Link check complete; look for any errors in the above output " \
+	      "or in build/linkcheck/output.txt."
+
+doctest:
+	$(SPHINXBUILD) -b doctest $(ALLSPHINXOPTS) build/doctest
+	@echo "Testing of doctests in the sources finished, look at the " \
+	      "results in build/doctest/output.txt."
diff --git a/docs/build/latex/Makefile b/docs/build/latex/Makefile
new file mode 100644
index 0000000..5c0d501
--- /dev/null
+++ b/docs/build/latex/Makefile
@@ -0,0 +1,58 @@
+# Makefile for Sphinx LaTeX output
+
+ALLDOCS = $(basename $(wildcard *.tex))
+ALLPDF = $(addsuffix .pdf,$(ALLDOCS))
+ALLDVI = $(addsuffix .dvi,$(ALLDOCS))
+
+# Prefix for archive names
+ARCHIVEPRREFIX =
+# Additional LaTeX options
+LATEXOPTS =
+
+all: $(ALLPDF)
+all-pdf: $(ALLPDF)
+all-dvi: $(ALLDVI)
+all-ps: all-dvi
+	for f in *.dvi; do dvips $$f; done
+
+zip: all-$(FMT)
+	mkdir $(ARCHIVEPREFIX)docs-$(FMT)
+	cp $(ALLPDF) $(ARCHIVEPREFIX)docs-$(FMT)
+	zip -q -r -9 $(ARCHIVEPREFIX)docs-$(FMT).zip $(ARCHIVEPREFIX)docs-$(FMT)
+	rm -r $(ARCHIVEPREFIX)docs-$(FMT)
+
+tar: all-$(FMT)
+	mkdir $(ARCHIVEPREFIX)docs-$(FMT)
+	cp $(ALLPDF) $(ARCHIVEPREFIX)docs-$(FMT)
+	tar cf $(ARCHIVEPREFIX)docs-$(FMT).tar $(ARCHIVEPREFIX)docs-$(FMT)
+	rm -r $(ARCHIVEPREFIX)docs-$(FMT)
+
+bz2: tar
+	bzip2 -9 -k $(ARCHIVEPREFIX)docs-$(FMT).tar
+
+# The number of LaTeX runs is quite conservative, but I don't expect it
+# to get run often, so the little extra time won't hurt.
+%.dvi: %.tex
+	latex $(LATEXOPTS) '$<'
+	latex $(LATEXOPTS) '$<'
+	latex $(LATEXOPTS) '$<'
+	-makeindex -s python.ist '$(basename $<).idx'
+	-makeindex -s python.ist '$(basename mod$<).idx'
+	latex $(LATEXOPTS) '$<'
+	latex $(LATEXOPTS) '$<'
+
+%.pdf: %.tex
+	pdflatex $(LATEXOPTS) '$<'
+	pdflatex $(LATEXOPTS) '$<'
+	pdflatex $(LATEXOPTS) '$<'
+	-makeindex -s python.ist '$(basename $<).idx'
+	-makeindex -s python.ist '$(basename mod$<).idx'
+	pdflatex $(LATEXOPTS) '$<'
+	pdflatex $(LATEXOPTS) '$<'
+
+clean:
+	rm -f *.pdf *.dvi *.ps
+	rm -f *.log *.ind *.aux *.toc *.syn *.idx *.out *.ilg *.pla
+
+.PHONY: all all-pdf all-dvi all-ps clean
+
diff --git a/docs/build/latex/modncclient.idx b/docs/build/latex/modncclient.idx
new file mode 100644
index 0000000..43f382a
--- /dev/null
+++ b/docs/build/latex/modncclient.idx
@@ -0,0 +1,5 @@
+\indexentry {ncclient.manager@{\texttt  {ncclient.manager}}|hyperpage}{3}
+\indexentry {ncclient.capabilities@{\texttt  {ncclient.capabilities}}|hyperpage}{4}
+\indexentry {ncclient.content@{\texttt  {ncclient.content}}|hyperpage}{5}
+\indexentry {ncclient.transport@{\texttt  {ncclient.transport}}|hyperpage}{7}
+\indexentry {ncclient.operations@{\texttt  {ncclient.operations}}|hyperpage}{9}
diff --git a/docs/build/latex/modncclient.ilg b/docs/build/latex/modncclient.ilg
new file mode 100644
index 0000000..7b0659b
--- /dev/null
+++ b/docs/build/latex/modncclient.ilg
@@ -0,0 +1,7 @@
+This is makeindex, version 2.15 [20-Nov-2007] (kpathsea + Thai support).
+Scanning style file ./python.ist......done (6 attributes redefined, 0 ignored).
+Scanning input file modncclient.idx....done (5 entries accepted, 0 rejected).
+Sorting entries....done (12 comparisons).
+Generating output file modncclient.ind....done (11 lines written, 0 warnings).
+Output written in modncclient.ind.
+Transcript written in modncclient.ilg.
diff --git a/docs/build/latex/modncclient.ind b/docs/build/latex/modncclient.ind
new file mode 100644
index 0000000..f46affd
--- /dev/null
+++ b/docs/build/latex/modncclient.ind
@@ -0,0 +1,11 @@
+\begin{theindex}
+\def\bigletter#1{{\Large\sffamily#1}\nopagebreak\vspace{1mm}}
+
+  \bigletter N
+  \item {\texttt  {ncclient.capabilities}}, \hyperpage{4}
+  \item {\texttt  {ncclient.content}}, \hyperpage{5}
+  \item {\texttt  {ncclient.manager}}, \hyperpage{3}
+  \item {\texttt  {ncclient.operations}}, \hyperpage{9}
+  \item {\texttt  {ncclient.transport}}, \hyperpage{7}
+
+\end{theindex}
diff --git a/docs/build/latex/ncclient.aux b/docs/build/latex/ncclient.aux
new file mode 100644
index 0000000..12dd217
--- /dev/null
+++ b/docs/build/latex/ncclient.aux
@@ -0,0 +1,56 @@
+\relax 
+\ifx\hyper@anchor\@undefined
+\global \let \oldcontentsline\contentsline
+\gdef \contentsline#1#2#3#4{\oldcontentsline{#1}{#2}{#3}}
+\global \let \oldnewlabel\newlabel
+\gdef \newlabel#1#2{\newlabelxx{#1}#2}
+\gdef \newlabelxx#1#2#3#4#5#6{\oldnewlabel{#1}{{#2}{#3}}}
+\AtEndDocument{\let \contentsline\oldcontentsline
+\let \newlabel\oldnewlabel}
+\else
+\global \let \hyper@last\relax 
+\fi
+
+\select@language{english}
+\@writefile{toc}{\select@language{english}}
+\@writefile{lof}{\select@language{english}}
+\@writefile{lot}{\select@language{english}}
+\@writefile{toc}{\contentsline {chapter}{\numberline {1}Introduction}{1}{chapter.1}}
+\@writefile{lof}{\addvspace {10\p@ }}
+\@writefile{lot}{\addvspace {10\p@ }}
+\@writefile{toc}{\contentsline {chapter}{\numberline {2}User documentation}{3}{chapter.2}}
+\@writefile{lof}{\addvspace {10\p@ }}
+\@writefile{lot}{\addvspace {10\p@ }}
+\@writefile{toc}{\contentsline {section}{\numberline {2.1}\texttt  {manager} module}{3}{section.2.1}}
+\@writefile{toc}{\contentsline {subsection}{\numberline {2.1.1}Dealing with RPC errors}{3}{subsection.2.1.1}}
+\@writefile{toc}{\contentsline {subsection}{\numberline {2.1.2}Manager instances}{3}{subsection.2.1.2}}
+\@writefile{toc}{\contentsline {section}{\numberline {2.2}\texttt  {capabilities} module}{4}{section.2.2}}
+\@writefile{toc}{\contentsline {section}{\numberline {2.3}\texttt  {content} module}{5}{section.2.3}}
+\@writefile{toc}{\contentsline {subsection}{\numberline {2.3.1}Namespaces}{5}{subsection.2.3.1}}
+\@writefile{toc}{\contentsline {subsection}{\numberline {2.3.2}DictTree XML representation}{5}{subsection.2.3.2}}
+\@writefile{toc}{\contentsline {subsection}{\numberline {2.3.3}Converting between different representations}{5}{subsection.2.3.3}}
+\@writefile{toc}{\contentsline {subsection}{\numberline {2.3.4}Other utility functions}{6}{subsection.2.3.4}}
+\@writefile{toc}{\contentsline {subsection}{\numberline {2.3.5}Errors}{7}{subsection.2.3.5}}
+\@writefile{toc}{\contentsline {section}{\numberline {2.4}\texttt  {transport} module}{7}{section.2.4}}
+\@writefile{toc}{\contentsline {subsection}{\numberline {2.4.1}Base types}{7}{subsection.2.4.1}}
+\@writefile{toc}{\contentsline {subsection}{\numberline {2.4.2}SSH session implementation}{7}{subsection.2.4.2}}
+\@writefile{toc}{\contentsline {subsection}{\numberline {2.4.3}Errors}{8}{subsection.2.4.3}}
+\@writefile{toc}{\contentsline {section}{\numberline {2.5}\texttt  {operations} module}{9}{section.2.5}}
+\@writefile{toc}{\contentsline {subsection}{\numberline {2.5.1}Base types}{9}{subsection.2.5.1}}
+\@writefile{toc}{\contentsline {subsection}{\numberline {2.5.2}NETCONF Operations}{10}{subsection.2.5.2}}
+\@writefile{toc}{\contentsline {subsubsection}{Dependencies}{10}{subsubsection*.2}}
+\@writefile{toc}{\contentsline {subsubsection}{Return type}{10}{subsubsection*.3}}
+\@writefile{toc}{\contentsline {subsubsection}{General notes on parameters}{10}{subsubsection*.4}}
+\@writefile{toc}{\contentsline {paragraph}{Source / target parameters}{10}{paragraph*.5}}
+\@writefile{toc}{\contentsline {paragraph}{Filter parameters}{10}{paragraph*.6}}
+\@writefile{toc}{\contentsline {subsubsection}{Retrieval operations}{10}{subsubsection*.7}}
+\@writefile{toc}{\contentsline {subsubsection}{Locking operations}{11}{subsubsection*.8}}
+\@writefile{toc}{\contentsline {subsubsection}{Configuration operations}{11}{subsubsection*.9}}
+\@writefile{toc}{\contentsline {subsubsection}{Session management operations}{12}{subsubsection*.10}}
+\@writefile{toc}{\contentsline {subsubsection}{Also useful}{13}{subsubsection*.11}}
+\@writefile{toc}{\contentsline {subsection}{\numberline {2.5.3}Errors}{13}{subsection.2.5.3}}
+\@writefile{toc}{\contentsline {chapter}{\numberline {3}Extending NCClient}{15}{chapter.3}}
+\@writefile{lof}{\addvspace {10\p@ }}
+\@writefile{lot}{\addvspace {10\p@ }}
+\@writefile{toc}{\contentsline {chapter}{Module Index}{17}{section*.12}}
+\@writefile{toc}{\contentsline {chapter}{Index}{19}{section*.13}}
diff --git a/docs/build/latex/ncclient.idx b/docs/build/latex/ncclient.idx
new file mode 100644
index 0000000..376559a
--- /dev/null
+++ b/docs/build/latex/ncclient.idx
@@ -0,0 +1,126 @@
+\indexentry{RFC!RFC 4741|hyperpage}{1}
+\indexentry{RFC!RFC 4741|hyperpage}{1}
+\indexentry{ncclient.manager (module)|hyperpage}{3}
+\indexentry{RAISE\_ALL (in module ncclient.manager)|hyperpage}{3}
+\indexentry{RAISE\_ERR (in module ncclient.manager)|hyperpage}{3}
+\indexentry{RAISE\_NONE (in module ncclient.manager)|hyperpage}{3}
+\indexentry{connect() (in module ncclient.manager)|hyperpage}{3}
+\indexentry{connect\_ssh() (in module ncclient.manager)|hyperpage}{3}
+\indexentry{Manager (class in ncclient.manager)|hyperpage}{3}
+\indexentry{set\_rpc\_error\_action() (ncclient.manager.Manager method)|hyperpage}{3}
+\indexentry{get() (ncclient.manager.Manager method)|hyperpage}{3}
+\indexentry{get\_config() (ncclient.manager.Manager method)|hyperpage}{3}
+\indexentry{edit\_config() (ncclient.manager.Manager method)|hyperpage}{3}
+\indexentry{copy\_config() (ncclient.manager.Manager method)|hyperpage}{3}
+\indexentry{validate() (ncclient.manager.Manager method)|hyperpage}{3}
+\indexentry{commit() (ncclient.manager.Manager method)|hyperpage}{4}
+\indexentry{discard\_changes() (ncclient.manager.Manager method)|hyperpage}{4}
+\indexentry{delete\_config() (ncclient.manager.Manager method)|hyperpage}{4}
+\indexentry{lock() (ncclient.manager.Manager method)|hyperpage}{4}
+\indexentry{unlock() (ncclient.manager.Manager method)|hyperpage}{4}
+\indexentry{close\_session() (ncclient.manager.Manager method)|hyperpage}{4}
+\indexentry{kill\_session() (ncclient.manager.Manager method)|hyperpage}{4}
+\indexentry{locked() (ncclient.manager.Manager method)|hyperpage}{4}
+\indexentry{close() (ncclient.manager.Manager method)|hyperpage}{4}
+\indexentry{client\_capabilities (ncclient.manager.Manager attribute)|hyperpage}{4}
+\indexentry{server\_capabilities (ncclient.manager.Manager attribute)|hyperpage}{4}
+\indexentry{session\_id (ncclient.manager.Manager attribute)|hyperpage}{4}
+\indexentry{connected (ncclient.manager.Manager attribute)|hyperpage}{4}
+\indexentry{ncclient.capabilities (module)|hyperpage}{4}
+\indexentry{CAPABILITIES (in module ncclient.capabilities)|hyperpage}{4}
+\indexentry{Capabilities (class in ncclient.capabilities)|hyperpage}{4}
+\indexentry{add() (ncclient.capabilities.Capabilities method)|hyperpage}{4}
+\indexentry{check() (ncclient.capabilities.Capabilities method)|hyperpage}{4}
+\indexentry{remove() (ncclient.capabilities.Capabilities method)|hyperpage}{4}
+\indexentry{ncclient.content (module)|hyperpage}{5}
+\indexentry{BASE\_NS (in module ncclient.content)|hyperpage}{5}
+\indexentry{qualify() (in module ncclient.content)|hyperpage}{5}
+\indexentry{unqualify() (in module ncclient.content)|hyperpage}{5}
+\indexentry{dtree2ele() (in module ncclient.content)|hyperpage}{5}
+\indexentry{dtree2xml() (in module ncclient.content)|hyperpage}{6}
+\indexentry{ele2dtree() (in module ncclient.content)|hyperpage}{6}
+\indexentry{ele2xml() (in module ncclient.content)|hyperpage}{6}
+\indexentry{xml2dtree() (in module ncclient.content)|hyperpage}{6}
+\indexentry{xml2ele() (in module ncclient.content)|hyperpage}{6}
+\indexentry{iselement() (in module ncclient.content)|hyperpage}{6}
+\indexentry{find() (in module ncclient.content)|hyperpage}{6}
+\indexentry{parse\_root() (in module ncclient.content)|hyperpage}{6}
+\indexentry{validated\_element() (in module ncclient.content)|hyperpage}{6}
+\indexentry{ContentError|hyperpage}{7}
+\indexentry{ncclient.transport (module)|hyperpage}{7}
+\indexentry{Session (class in ncclient.transport)|hyperpage}{7}
+\indexentry{add\_listener() (ncclient.transport.Session method)|hyperpage}{7}
+\indexentry{remove\_listener() (ncclient.transport.Session method)|hyperpage}{7}
+\indexentry{get\_listener\_instance() (ncclient.transport.Session method)|hyperpage}{7}
+\indexentry{client\_capabilities (ncclient.transport.Session attribute)|hyperpage}{7}
+\indexentry{server\_capabilities (ncclient.transport.Session attribute)|hyperpage}{7}
+\indexentry{connected (ncclient.transport.Session attribute)|hyperpage}{7}
+\indexentry{id (ncclient.transport.Session attribute)|hyperpage}{7}
+\indexentry{can\_pipeline (ncclient.transport.Session attribute)|hyperpage}{7}
+\indexentry{SessionListener (class in ncclient.transport)|hyperpage}{7}
+\indexentry{callback() (ncclient.transport.SessionListener method)|hyperpage}{7}
+\indexentry{errback() (ncclient.transport.SessionListener method)|hyperpage}{7}
+\indexentry{default\_unknown\_host\_cb() (ncclient.transport.ssh static method)|hyperpage}{7}
+\indexentry{SSHSession (class in ncclient.transport)|hyperpage}{8}
+\indexentry{RFC!RFC 4742|hyperpage}{8}
+\indexentry{connect() (ncclient.transport.SSHSession method)|hyperpage}{8}
+\indexentry{load\_known\_hosts() (ncclient.transport.SSHSession method)|hyperpage}{8}
+\indexentry{transport (ncclient.transport.SSHSession attribute)|hyperpage}{8}
+\indexentry{TransportError|hyperpage}{8}
+\indexentry{SessionCloseError|hyperpage}{8}
+\indexentry{SSHError|hyperpage}{8}
+\indexentry{AuthenticationError|hyperpage}{8}
+\indexentry{SSHUnknownHostError|hyperpage}{8}
+\indexentry{ncclient.operations (module)|hyperpage}{9}
+\indexentry{RPC (class in ncclient.operations.rpc)|hyperpage}{9}
+\indexentry{set\_async() (ncclient.operations.rpc.RPC method)|hyperpage}{9}
+\indexentry{set\_timeout() (ncclient.operations.rpc.RPC method)|hyperpage}{9}
+\indexentry{reply (ncclient.operations.rpc.RPC attribute)|hyperpage}{9}
+\indexentry{error (ncclient.operations.rpc.RPC attribute)|hyperpage}{9}
+\indexentry{event (ncclient.operations.rpc.RPC attribute)|hyperpage}{9}
+\indexentry{async (ncclient.operations.rpc.RPC attribute)|hyperpage}{9}
+\indexentry{timeout (ncclient.operations.rpc.RPC attribute)|hyperpage}{9}
+\indexentry{id (ncclient.operations.rpc.RPC attribute)|hyperpage}{9}
+\indexentry{session (ncclient.operations.rpc.RPC attribute)|hyperpage}{9}
+\indexentry{RPCReply (class in ncclient.operations.rpc)|hyperpage}{9}
+\indexentry{ok (ncclient.operations.rpc.RPCReply attribute)|hyperpage}{9}
+\indexentry{error (ncclient.operations.rpc.RPCReply attribute)|hyperpage}{9}
+\indexentry{errors (ncclient.operations.rpc.RPCReply attribute)|hyperpage}{9}
+\indexentry{RPCError (class in ncclient.operations.rpc)|hyperpage}{9}
+\indexentry{type (ncclient.operations.rpc.RPCError attribute)|hyperpage}{9}
+\indexentry{severity (ncclient.operations.rpc.RPCError attribute)|hyperpage}{9}
+\indexentry{tag (ncclient.operations.rpc.RPCError attribute)|hyperpage}{9}
+\indexentry{path (ncclient.operations.rpc.RPCError attribute)|hyperpage}{9}
+\indexentry{message (ncclient.operations.rpc.RPCError attribute)|hyperpage}{10}
+\indexentry{info (ncclient.operations.rpc.RPCError attribute)|hyperpage}{10}
+\indexentry{Get (class in ncclient.operations)|hyperpage}{10}
+\indexentry{request() (ncclient.operations.Get method)|hyperpage}{10}
+\indexentry{GetConfig (class in ncclient.operations)|hyperpage}{11}
+\indexentry{request() (ncclient.operations.GetConfig method)|hyperpage}{11}
+\indexentry{GetReply (class in ncclient.operations)|hyperpage}{11}
+\indexentry{data (ncclient.operations.GetReply attribute)|hyperpage}{11}
+\indexentry{data\_xml (ncclient.operations.GetReply attribute)|hyperpage}{11}
+\indexentry{data\_dtree (ncclient.operations.GetReply attribute)|hyperpage}{11}
+\indexentry{data\_ele (ncclient.operations.GetReply attribute)|hyperpage}{11}
+\indexentry{Lock (class in ncclient.operations)|hyperpage}{11}
+\indexentry{request() (ncclient.operations.Lock method)|hyperpage}{11}
+\indexentry{Unlock (class in ncclient.operations)|hyperpage}{11}
+\indexentry{request() (ncclient.operations.Unlock method)|hyperpage}{11}
+\indexentry{EditConfig (class in ncclient.operations)|hyperpage}{11}
+\indexentry{request() (ncclient.operations.EditConfig method)|hyperpage}{11}
+\indexentry{CopyConfig (class in ncclient.operations)|hyperpage}{12}
+\indexentry{request() (ncclient.operations.CopyConfig method)|hyperpage}{12}
+\indexentry{DeleteConfig (class in ncclient.operations)|hyperpage}{12}
+\indexentry{request() (ncclient.operations.DeleteConfig method)|hyperpage}{12}
+\indexentry{Validate (class in ncclient.operations)|hyperpage}{12}
+\indexentry{request() (ncclient.operations.Validate method)|hyperpage}{12}
+\indexentry{Commit (class in ncclient.operations)|hyperpage}{12}
+\indexentry{request() (ncclient.operations.Commit method)|hyperpage}{12}
+\indexentry{DiscardChanges (class in ncclient.operations)|hyperpage}{12}
+\indexentry{request() (ncclient.operations.DiscardChanges method)|hyperpage}{12}
+\indexentry{CloseSession (class in ncclient.operations)|hyperpage}{12}
+\indexentry{KillSession (class in ncclient.operations)|hyperpage}{12}
+\indexentry{LockContext (class in ncclient.operations)|hyperpage}{13}
+\indexentry{OperationError|hyperpage}{13}
+\indexentry{TimeoutExpiredError|hyperpage}{13}
+\indexentry{MissingCapabilityError|hyperpage}{13}
diff --git a/docs/build/latex/ncclient.ilg b/docs/build/latex/ncclient.ilg
new file mode 100644
index 0000000..10efd54
--- /dev/null
+++ b/docs/build/latex/ncclient.ilg
@@ -0,0 +1,7 @@
+This is makeindex, version 2.15 [20-Nov-2007] (kpathsea + Thai support).
+Scanning style file ./python.ist......done (6 attributes redefined, 0 ignored).
+Scanning input file ncclient.idx....done (126 entries accepted, 0 rejected).
+Sorting entries....done (923 comparisons).
+Generating output file ncclient.ind....done (192 lines written, 0 warnings).
+Output written in ncclient.ind.
+Transcript written in ncclient.ilg.
diff --git a/docs/build/latex/ncclient.ind b/docs/build/latex/ncclient.ind
new file mode 100644
index 0000000..6f7aa2e
--- /dev/null
+++ b/docs/build/latex/ncclient.ind
@@ -0,0 +1,192 @@
+\begin{theindex}
+\def\bigletter#1{{\Large\sffamily#1}\nopagebreak\vspace{1mm}}
+
+  \bigletter A
+  \item add() (ncclient.capabilities.Capabilities method), \hyperpage{4}
+  \item add\_listener() (ncclient.transport.Session method), \hyperpage{7}
+  \item async (ncclient.operations.rpc.RPC attribute), \hyperpage{9}
+  \item AuthenticationError, \hyperpage{8}
+
+  \indexspace
+  \bigletter B
+  \item BASE\_NS (in module ncclient.content), \hyperpage{5}
+
+  \indexspace
+  \bigletter C
+  \item callback() (ncclient.transport.SessionListener method), \hyperpage{7}
+  \item can\_pipeline (ncclient.transport.Session attribute), \hyperpage{7}
+  \item Capabilities (class in ncclient.capabilities), \hyperpage{4}
+  \item CAPABILITIES (in module ncclient.capabilities), \hyperpage{4}
+  \item check() (ncclient.capabilities.Capabilities method), \hyperpage{4}
+  \item client\_capabilities (ncclient.manager.Manager attribute), \hyperpage{4}
+  \item client\_capabilities (ncclient.transport.Session attribute), \hyperpage{7}
+  \item close() (ncclient.manager.Manager method), \hyperpage{4}
+  \item close\_session() (ncclient.manager.Manager method), \hyperpage{4}
+  \item CloseSession (class in ncclient.operations), \hyperpage{12}
+  \item Commit (class in ncclient.operations), \hyperpage{12}
+  \item commit() (ncclient.manager.Manager method), \hyperpage{4}
+  \item connect() (in module ncclient.manager), \hyperpage{3}
+  \item connect() (ncclient.transport.SSHSession method), \hyperpage{8}
+  \item connect\_ssh() (in module ncclient.manager), \hyperpage{3}
+  \item connected (ncclient.manager.Manager attribute), \hyperpage{4}
+  \item connected (ncclient.transport.Session attribute), \hyperpage{7}
+  \item ContentError, \hyperpage{7}
+  \item copy\_config() (ncclient.manager.Manager method), \hyperpage{3}
+  \item CopyConfig (class in ncclient.operations), \hyperpage{12}
+
+  \indexspace
+  \bigletter D
+  \item data (ncclient.operations.GetReply attribute), \hyperpage{11}
+  \item data\_dtree (ncclient.operations.GetReply attribute), \hyperpage{11}
+  \item data\_ele (ncclient.operations.GetReply attribute), \hyperpage{11}
+  \item data\_xml (ncclient.operations.GetReply attribute), \hyperpage{11}
+  \item default\_unknown\_host\_cb() (ncclient.transport.ssh static method), \hyperpage{7}
+  \item delete\_config() (ncclient.manager.Manager method), \hyperpage{4}
+  \item DeleteConfig (class in ncclient.operations), \hyperpage{12}
+  \item discard\_changes() (ncclient.manager.Manager method), \hyperpage{4}
+  \item DiscardChanges (class in ncclient.operations), \hyperpage{12}
+  \item dtree2ele() (in module ncclient.content), \hyperpage{5}
+  \item dtree2xml() (in module ncclient.content), \hyperpage{6}
+
+  \indexspace
+  \bigletter E
+  \item edit\_config() (ncclient.manager.Manager method), \hyperpage{3}
+  \item EditConfig (class in ncclient.operations), \hyperpage{11}
+  \item ele2dtree() (in module ncclient.content), \hyperpage{6}
+  \item ele2xml() (in module ncclient.content), \hyperpage{6}
+  \item errback() (ncclient.transport.SessionListener method), \hyperpage{7}
+  \item error (ncclient.operations.rpc.RPC attribute), \hyperpage{9}
+  \item error (ncclient.operations.rpc.RPCReply attribute), \hyperpage{9}
+  \item errors (ncclient.operations.rpc.RPCReply attribute), \hyperpage{9}
+  \item event (ncclient.operations.rpc.RPC attribute), \hyperpage{9}
+
+  \indexspace
+  \bigletter F
+  \item find() (in module ncclient.content), \hyperpage{6}
+
+  \indexspace
+  \bigletter G
+  \item Get (class in ncclient.operations), \hyperpage{10}
+  \item get() (ncclient.manager.Manager method), \hyperpage{3}
+  \item get\_config() (ncclient.manager.Manager method), \hyperpage{3}
+  \item get\_listener\_instance() (ncclient.transport.Session method), \hyperpage{7}
+  \item GetConfig (class in ncclient.operations), \hyperpage{11}
+  \item GetReply (class in ncclient.operations), \hyperpage{11}
+
+  \indexspace
+  \bigletter I
+  \item id (ncclient.operations.rpc.RPC attribute), \hyperpage{9}
+  \item id (ncclient.transport.Session attribute), \hyperpage{7}
+  \item info (ncclient.operations.rpc.RPCError attribute), \hyperpage{10}
+  \item iselement() (in module ncclient.content), \hyperpage{6}
+
+  \indexspace
+  \bigletter K
+  \item kill\_session() (ncclient.manager.Manager method), \hyperpage{4}
+  \item KillSession (class in ncclient.operations), \hyperpage{12}
+
+  \indexspace
+  \bigletter L
+  \item load\_known\_hosts() (ncclient.transport.SSHSession method), \hyperpage{8}
+  \item Lock (class in ncclient.operations), \hyperpage{11}
+  \item lock() (ncclient.manager.Manager method), \hyperpage{4}
+  \item LockContext (class in ncclient.operations), \hyperpage{13}
+  \item locked() (ncclient.manager.Manager method), \hyperpage{4}
+
+  \indexspace
+  \bigletter M
+  \item Manager (class in ncclient.manager), \hyperpage{3}
+  \item message (ncclient.operations.rpc.RPCError attribute), \hyperpage{10}
+  \item MissingCapabilityError, \hyperpage{13}
+
+  \indexspace
+  \bigletter N
+  \item ncclient.capabilities (module), \hyperpage{4}
+  \item ncclient.content (module), \hyperpage{5}
+  \item ncclient.manager (module), \hyperpage{3}
+  \item ncclient.operations (module), \hyperpage{9}
+  \item ncclient.transport (module), \hyperpage{7}
+
+  \indexspace
+  \bigletter O
+  \item ok (ncclient.operations.rpc.RPCReply attribute), \hyperpage{9}
+  \item OperationError, \hyperpage{13}
+
+  \indexspace
+  \bigletter P
+  \item parse\_root() (in module ncclient.content), \hyperpage{6}
+  \item path (ncclient.operations.rpc.RPCError attribute), \hyperpage{9}
+
+  \indexspace
+  \bigletter Q
+  \item qualify() (in module ncclient.content), \hyperpage{5}
+
+  \indexspace
+  \bigletter R
+  \item RAISE\_ALL (in module ncclient.manager), \hyperpage{3}
+  \item RAISE\_ERR (in module ncclient.manager), \hyperpage{3}
+  \item RAISE\_NONE (in module ncclient.manager), \hyperpage{3}
+  \item remove() (ncclient.capabilities.Capabilities method), \hyperpage{4}
+  \item remove\_listener() (ncclient.transport.Session method), \hyperpage{7}
+  \item reply (ncclient.operations.rpc.RPC attribute), \hyperpage{9}
+  \item request() (ncclient.operations.Commit method), \hyperpage{12}
+  \item request() (ncclient.operations.CopyConfig method), \hyperpage{12}
+  \item request() (ncclient.operations.DeleteConfig method), \hyperpage{12}
+  \item request() (ncclient.operations.DiscardChanges method), \hyperpage{12}
+  \item request() (ncclient.operations.EditConfig method), \hyperpage{11}
+  \item request() (ncclient.operations.Get method), \hyperpage{10}
+  \item request() (ncclient.operations.GetConfig method), \hyperpage{11}
+  \item request() (ncclient.operations.Lock method), \hyperpage{11}
+  \item request() (ncclient.operations.Unlock method), \hyperpage{11}
+  \item request() (ncclient.operations.Validate method), \hyperpage{12}
+  \item RFC
+    \subitem RFC 4741, \hyperpage{1}
+    \subitem RFC 4742, \hyperpage{8}
+  \item RPC (class in ncclient.operations.rpc), \hyperpage{9}
+  \item RPCError (class in ncclient.operations.rpc), \hyperpage{9}
+  \item RPCReply (class in ncclient.operations.rpc), \hyperpage{9}
+
+  \indexspace
+  \bigletter S
+  \item server\_capabilities (ncclient.manager.Manager attribute), \hyperpage{4}
+  \item server\_capabilities (ncclient.transport.Session attribute), \hyperpage{7}
+  \item Session (class in ncclient.transport), \hyperpage{7}
+  \item session (ncclient.operations.rpc.RPC attribute), \hyperpage{9}
+  \item session\_id (ncclient.manager.Manager attribute), \hyperpage{4}
+  \item SessionCloseError, \hyperpage{8}
+  \item SessionListener (class in ncclient.transport), \hyperpage{7}
+  \item set\_async() (ncclient.operations.rpc.RPC method), \hyperpage{9}
+  \item set\_rpc\_error\_action() (ncclient.manager.Manager method), \hyperpage{3}
+  \item set\_timeout() (ncclient.operations.rpc.RPC method), \hyperpage{9}
+  \item severity (ncclient.operations.rpc.RPCError attribute), \hyperpage{9}
+  \item SSHError, \hyperpage{8}
+  \item SSHSession (class in ncclient.transport), \hyperpage{8}
+  \item SSHUnknownHostError, \hyperpage{8}
+
+  \indexspace
+  \bigletter T
+  \item tag (ncclient.operations.rpc.RPCError attribute), \hyperpage{9}
+  \item timeout (ncclient.operations.rpc.RPC attribute), \hyperpage{9}
+  \item TimeoutExpiredError, \hyperpage{13}
+  \item transport (ncclient.transport.SSHSession attribute), \hyperpage{8}
+  \item TransportError, \hyperpage{8}
+  \item type (ncclient.operations.rpc.RPCError attribute), \hyperpage{9}
+
+  \indexspace
+  \bigletter U
+  \item Unlock (class in ncclient.operations), \hyperpage{11}
+  \item unlock() (ncclient.manager.Manager method), \hyperpage{4}
+  \item unqualify() (in module ncclient.content), \hyperpage{5}
+
+  \indexspace
+  \bigletter V
+  \item Validate (class in ncclient.operations), \hyperpage{12}
+  \item validate() (ncclient.manager.Manager method), \hyperpage{3}
+  \item validated\_element() (in module ncclient.content), \hyperpage{6}
+
+  \indexspace
+  \bigletter X
+  \item xml2dtree() (in module ncclient.content), \hyperpage{6}
+  \item xml2ele() (in module ncclient.content), \hyperpage{6}
+
+\end{theindex}
